diff --git a/ldap/servers/slapd/back-ldbm/db-bdb/bdb_layer.c b/ldap/servers/slapd/back-ldbm/db-bdb/bdb_layer.c
index 464f89f..1291e4c 100644
--- a/ldap/servers/slapd/back-ldbm/db-bdb/bdb_layer.c
+++ b/ldap/servers/slapd/back-ldbm/db-bdb/bdb_layer.c
@@ -95,6 +95,7 @@ static PRLock *sync_txn_log_flush = NULL;
 static PRCondVar *sync_txn_log_flush_done = NULL;
 static PRCondVar *sync_txn_log_do_flush = NULL;
 static int bdb_db_remove_ex(bdb_db_env *env, char const path[], char const dbName[], PRBool use_lock);
+static int bdb_db_compact_one_db(DB *db, ldbm_instance *inst);
 static int bdb_restore_file_check(struct ldbminfo *li);
 
 #define MEGABYTE (1024 * 1024)
@@ -2345,9 +2346,12 @@ bdb_get_db(backend *be, char *indexname, int open_flag, struct attrinfo *ai, DB 
         goto out;
 
     dbp = *ppDB;
-    return_value = _dblayer_set_db_callbacks(conf, dbp, ai);
-    if (return_value)
-        goto out;
+    if (ai) {
+        return_value = _dblayer_set_db_callbacks(conf, dbp, ai);
+        if (return_value) {
+            goto out;
+        }
+    }
 
     /* The subname argument allows applications to have
      * subdatabases, i.e., multiple databases inside of a single
@@ -2379,9 +2383,12 @@ bdb_get_db(backend *be, char *indexname, int open_flag, struct attrinfo *ai, DB 
             goto out;
         }
         dbp = *ppDB;
-        return_value = _dblayer_set_db_callbacks(conf, dbp, ai);
-        if (return_value)
-            goto out;
+        if (ai) {
+            return_value = _dblayer_set_db_callbacks(conf, dbp, ai);
+            if (return_value) {
+                goto out;
+            }
+        }
 
         slapi_ch_free_string(&abs_file_name);
     }
@@ -2457,6 +2464,62 @@ bdb_db_remove(bdb_db_env *env, char const path[], char const dbName[])
     return (bdb_db_remove_ex(env, path, dbName, PR_TRUE));
 }
 
+static int
+bdb_db_compact_one_db(DB *db, ldbm_instance *inst)
+{
+    DBTYPE type;
+    int rc = 0;
+    back_txn txn;
+    DB_COMPACT c_data = {0};
+
+    rc = db->get_type(db, &type);
+    if (rc) {
+        slapi_log_err(SLAPI_LOG_ERR, "bdb_db_compact_one_db",
+                      "compactdb: failed to determine db type for %s: db error - %d %s\n",
+                      inst->inst_name, rc, db_strerror(rc));
+        return rc;
+    }
+
+    rc = dblayer_txn_begin(inst->inst_be, NULL, &txn);
+    if (rc) {
+        slapi_log_err(SLAPI_LOG_ERR, "bdb_db_compact_one_db", "compactdb: transaction begin failed: %d\n", rc);
+        return rc;
+    }
+    /*
+     * https://docs.oracle.com/cd/E17275_01/html/api_reference/C/BDB-C_APIReference.pdf
+     * "DB_FREELIST_ONLY
+     * Do no page compaction, only returning pages to the filesystem that are already free and at the end
+     * of the file. This flag must be set if the database is a Hash access method database."
+     *
+     */
+
+    uint32_t compact_flags = DB_FREE_SPACE;
+    if (type == DB_HASH) {
+        compact_flags |= DB_FREELIST_ONLY;
+    }
+    rc = db->compact(db, txn.back_txn_txn, NULL /*start*/, NULL /*stop*/,
+                     &c_data, compact_flags, NULL /*end*/);
+    if (rc) {
+        slapi_log_err(SLAPI_LOG_ERR, "bdb_db_compact_one_db",
+                      "compactdb: failed to compact %s; db error - %d %s\n",
+                      inst->inst_name, rc, db_strerror(rc));
+        if ((rc = dblayer_txn_abort(inst->inst_be, &txn))) {
+            slapi_log_err(SLAPI_LOG_ERR, "bdb_db_compact_one_db", "compactdb: failed to abort txn (%s) db error - %d %s\n",
+                          inst->inst_name, rc, db_strerror(rc));
+        }
+    } else {
+        slapi_log_err(SLAPI_LOG_NOTICE, "bdb_db_compact_one_db",
+                      "compactdb: compact %s - %d pages freed\n",
+                      inst->inst_name, c_data.compact_pages_free);
+        if ((rc = dblayer_txn_commit(inst->inst_be, &txn))) {
+            slapi_log_err(SLAPI_LOG_ERR, "bdb_db_compact_one_db", "compactdb: failed to commit txn (%s) db error - %d %s\n",
+                          inst->inst_name, rc, db_strerror(rc));
+        }
+    }
+
+    return rc;
+}
+
 #define DBLAYER_CACHE_DELAY PR_MillisecondsToInterval(250)
 int
 bdb_rm_db_file(backend *be, struct attrinfo *a, PRBool use_lock, int no_force_checkpoint)
@@ -3554,7 +3617,7 @@ bdb_start_checkpoint_thread(struct ldbminfo *li)
 }
 
 /*
- * checkpoint thread -- borrow the timing for compacting id2entry, as well.
+ * checkpoint thread -- borrow the timing for compacting id2entry, and eventually changelog, as well.
  */
 static int
 checkpoint_threadmain(void *param)
@@ -3573,7 +3636,6 @@ checkpoint_threadmain(void *param)
     time_t checkpoint_interval_update = 0;
     time_t compactdb_interval = 0;
     time_t checkpoint_interval = 0;
-    back_txn txn;
 
     PR_ASSERT(NULL != param);
     li = (struct ldbminfo *)param;
@@ -3706,7 +3768,6 @@ checkpoint_threadmain(void *param)
             Object *inst_obj;
             ldbm_instance *inst;
             DB *db = NULL;
-            DB_COMPACT c_data = {0};
 
             for (inst_obj = objset_first_obj(li->li_instance_set);
                  inst_obj;
@@ -3719,58 +3780,26 @@ checkpoint_threadmain(void *param)
                 slapi_log_err(SLAPI_LOG_NOTICE, "checkpoint_threadmain", "Compacting DB start: %s\n",
                               inst->inst_name);
 
-                /*
-                 * It's possible for this to heap us after free because when we access db
-                 * *just* as the server shut's down, we don't know it. So we should probably
-                 * do something like wrapping access to the db var in a rwlock, and have "read"
-                 * to access, and take writes to change the state. This would prevent the issue.
-                 */
-                DBTYPE type;
-                rc = db->get_type(db, &type);
+                rc = bdb_db_compact_one_db(db, inst);
                 if (rc) {
                     slapi_log_err(SLAPI_LOG_ERR, "checkpoint_threadmain",
-                                  "compactdb: failed to determine db type for %s: db error - %d %s\n",
-                                  inst->inst_name, rc, db_strerror(rc));
-                    continue;
-                }
-
-                rc = dblayer_txn_begin(inst->inst_be, NULL, &txn);
-                if (rc) {
-                    slapi_log_err(SLAPI_LOG_ERR, "checkpoint_threadmain", "compactdb: transaction begin failed: %d\n", rc);
+                                  "compactdb: failed to compact id2entry for %s; db error - %d %s\n",
+                                   inst->inst_name, rc, db_strerror(rc));
                     break;
                 }
-                /*
-                 * https://docs.oracle.com/cd/E17275_01/html/api_reference/C/BDB-C_APIReference.pdf
-                 * "DB_FREELIST_ONLY
-                 * Do no page compaction, only returning pages to the filesystem that are already free and at the end
-                 * of the file. This flag must be set if the database is a Hash access method database."
-                 *
+
+                /* compact changelog db */
+                /* NOTE (LK) this is now done along regular compaction, 
+                 * if it should be configurable add a switch to changelog config
                  */
+                dblayer_get_changelog(inst->inst_be, &db, 0);
 
-                uint32_t compact_flags = DB_FREE_SPACE;
-                if (type == DB_HASH) {
-                    compact_flags |= DB_FREELIST_ONLY;
-                }
-                rc = db->compact(db, txn.back_txn_txn, NULL /*start*/, NULL /*stop*/,
-                                 &c_data, compact_flags, NULL /*end*/);
+                rc = bdb_db_compact_one_db(db, inst);
                 if (rc) {
                     slapi_log_err(SLAPI_LOG_ERR, "checkpoint_threadmain",
-                                  "compactdb: failed to compact %s; db error - %d %s\n",
-                                  inst->inst_name, rc, db_strerror(rc));
-                    if ((rc = dblayer_txn_abort(inst->inst_be, &txn))) {
-                        slapi_log_err(SLAPI_LOG_ERR, "checkpoint_threadmain", "compactdb: failed to abort txn (%s) db error - %d %s\n",
-                                      inst->inst_name, rc, db_strerror(rc));
-                        break;
-                    }
-                } else {
-                    slapi_log_err(SLAPI_LOG_NOTICE, "checkpoint_threadmain",
-                                  "compactdb: compact %s - %d pages freed\n",
-                                  inst->inst_name, c_data.compact_pages_free);
-                    if ((rc = dblayer_txn_commit(inst->inst_be, &txn))) {
-                        slapi_log_err(SLAPI_LOG_ERR, "checkpoint_threadmain", "compactdb: failed to commit txn (%s) db error - %d %s\n",
-                                      inst->inst_name, rc, db_strerror(rc));
-                        break;
-                    }
+                                  "compactdb: failed to compact changelog for %s; db error - %d %s\n",
+                                   inst->inst_name, rc, db_strerror(rc));
+                    break;
                 }
             }
             compactdb_interval = compactdb_interval_update;
@@ -4206,6 +4235,12 @@ _dblayer_delete_instance_dir(ldbm_instance *inst, int startdb)
         if (pEnv &&
             /* PL_strcmp takes NULL arg */
             (PL_strcmp(LDBM_FILENAME_SUFFIX, strrchr(direntry->name, '.')) == 0)) {
+            if (strcmp(direntry->name, "changelog.db") == 0) {
+                /* do not delete the changelog, if it no longer
+                 * matches the database it will be recreated later
+                 */
+                continue;
+            }
             rval = bdb_db_remove_ex(pEnv, filename, 0, PR_TRUE);
         } else {
             rval = ldbm_delete_dirs(filename);
@@ -4221,8 +4256,10 @@ _dblayer_delete_instance_dir(ldbm_instance *inst, int startdb)
     }
 done:
     /* remove the directory itself too */
+    /* no
     if (0 == rval)
         PR_RmDir(inst_dirp);
+    */
     if (inst_dirp != inst_dir)
         slapi_ch_free_string(&inst_dirp);
     return rval;
@@ -4783,84 +4820,6 @@ out:
     return return_value;
 }
 
-/*
- * Get changelogdir from cn=changelog5,cn=config
- * The value does not have trailing spaces nor slashes.
- * The changelogdir value must be a fullpath.
- */
-static int
-_dblayer_get_changelogdir(struct ldbminfo *li, char **changelogdir)
-{
-    Slapi_PBlock *pb = NULL;
-    Slapi_Entry **entries = NULL;
-    Slapi_Attr *attr = NULL;
-    Slapi_Value *v = NULL;
-    const char *s = NULL;
-    char *attrs[2];
-    int rc = -1;
-
-    if (NULL == li || NULL == changelogdir) {
-        slapi_log_err(SLAPI_LOG_ERR,
-                      "_dblayer_get_changelogdir", "Invalid arg: "
-                                                   "li: 0x%p, changelogdir: 0x%p\n",
-                      li, changelogdir);
-        return rc;
-    }
-    *changelogdir = NULL;
-
-    pb = slapi_pblock_new();
-    attrs[0] = CHANGELOGDIRATTR;
-    attrs[1] = NULL;
-    slapi_search_internal_set_pb(pb, CHANGELOGENTRY,
-                                 LDAP_SCOPE_BASE, "cn=*", attrs, 0, NULL, NULL,
-                                 li->li_identity, 0);
-    slapi_search_internal_pb(pb);
-    slapi_pblock_get(pb, SLAPI_PLUGIN_INTOP_RESULT, &rc);
-
-    if (LDAP_NO_SUCH_OBJECT == rc) {
-        /* No changelog; Most likely standalone or not a master. */
-        rc = LDAP_SUCCESS;
-        goto bail;
-    }
-    if (LDAP_SUCCESS != rc) {
-        slapi_log_err(SLAPI_LOG_ERR,
-                      "_dblayer_get_changelogdir", "Failed to search \"%s\"\n", CHANGELOGENTRY);
-        goto bail;
-    }
-    /* rc == LDAP_SUCCESS */
-    slapi_pblock_get(pb, SLAPI_PLUGIN_INTOP_SEARCH_ENTRIES, &entries);
-    if (NULL == entries) {
-        /* No changelog */
-        goto bail;
-    }
-    /* There should be only one entry. */
-    rc = slapi_entry_attr_find(entries[0], CHANGELOGDIRATTR, &attr);
-    if (rc || NULL == attr) {
-        /* No changelog dir */
-        rc = LDAP_SUCCESS;
-        goto bail;
-    }
-    rc = slapi_attr_first_value(attr, &v);
-    if (rc || NULL == v) {
-        /* No changelog dir */
-        rc = LDAP_SUCCESS;
-        goto bail;
-    }
-    rc = LDAP_SUCCESS;
-    s = slapi_value_get_string(v);
-    if (NULL == s) {
-        /* No changelog dir */
-        goto bail;
-    }
-    *changelogdir = slapi_ch_strdup(s);
-    /* Remove trailing spaces and '/' if any */
-    normalize_dir(*changelogdir);
-bail:
-    slapi_free_search_results_internal(pb);
-    slapi_pblock_destroy(pb);
-    return rc;
-}
-
 /* Destination Directory is an absolute pathname */
 int
 bdb_backup(struct ldbminfo *li, char *dest_dir, Slapi_Task *task)
@@ -4869,6 +4828,7 @@ bdb_backup(struct ldbminfo *li, char *dest_dir, Slapi_Task *task)
     bdb_config *conf = NULL;
     char **listA = NULL, **listB = NULL, **listi, **listj, *prefix;
     char *home_dir = NULL;
+    char *db_dir = NULL;
     int return_value = -1;
     char *pathname1;
     char *pathname2;
@@ -4883,6 +4843,9 @@ bdb_backup(struct ldbminfo *li, char *dest_dir, Slapi_Task *task)
     conf = (bdb_config *)li->li_dblayer_config;
     priv = li->li_dblayer_private;
     PR_ASSERT(NULL != priv);
+
+    db_dir = bdb_get_db_dir(li);
+
     home_dir = bdb_get_home_dir(li, NULL);
     if (NULL == home_dir || '\0' == *home_dir) {
         slapi_log_err(SLAPI_LOG_ERR,
@@ -4998,46 +4961,6 @@ bdb_backup(struct ldbminfo *li, char *dest_dir, Slapi_Task *task)
             if (inst_dirp != inst_dir)
                 slapi_ch_free_string(&inst_dirp);
         }
-        /* Get changelogdir, if any */
-        _dblayer_get_changelogdir(li, &changelogdir);
-        if (changelogdir) {
-            /* dest dir for changelog: dest_dir/repl_changelog_backup  */
-            char *changelog_destdir = slapi_ch_smprintf("%s/%s",
-                                                        dest_dir, CHANGELOG_BACKUPDIR);
-            return_value = bdb_copy_directory(li, task, changelogdir,
-                                                  changelog_destdir,
-                                                  0 /* backup */,
-                                                  &cnt, 0, 1);
-            if (return_value) {
-                slapi_log_err(SLAPI_LOG_ERR,
-                              "dblayer_backup", "Error in copying directory "
-                                                "(%s -> %s): err=%d\n",
-                              changelogdir, changelog_destdir, return_value);
-                if (task) {
-                    slapi_task_log_notice(task,
-                                          "Backup: error in copying directory "
-                                          "(%s -> %s): err=%d\n",
-                                          changelogdir, changelog_destdir, return_value);
-                }
-                slapi_ch_free_string(&changelog_destdir);
-                goto bail;
-            }
-            /* Copy DBVERSION */
-            pathname1 = slapi_ch_smprintf("%s/%s",
-                                          changelogdir, DBVERSION_FILENAME);
-            pathname2 = slapi_ch_smprintf("%s/%s",
-                                          changelog_destdir, DBVERSION_FILENAME);
-            return_value = dblayer_copyfile(pathname1, pathname2,
-                                            0, priv->dblayer_file_mode);
-            slapi_ch_free_string(&pathname2);
-            slapi_ch_free_string(&changelog_destdir);
-            if (0 > return_value) {
-                slapi_log_err(SLAPI_LOG_ERR, "dblayer_backup", "Failed to copy file %s\n", pathname1);
-                slapi_ch_free_string(&pathname1);
-                goto bail;
-            }
-            slapi_ch_free_string(&pathname1);
-        }
         if (conf->bdb_enable_transactions) {
             /* now, get the list of logfiles that still exist */
             return_value = LOG_ARCHIVE(((bdb_db_env *)priv->dblayer_env)->bdb_DB_ENV,
@@ -5088,7 +5011,7 @@ bdb_backup(struct ldbminfo *li, char *dest_dir, Slapi_Task *task)
                     (0 != strlen(conf->bdb_log_directory))) {
                     prefix = conf->bdb_log_directory;
                 } else {
-                    prefix = home_dir;
+                    prefix = db_dir;
                 }
                 /* log files have the same filename len(100 is a safety net:) */
                 p1len = strlen(prefix) + strlen(*listB) + 100;
@@ -5368,13 +5291,6 @@ bdb_restore(struct ldbminfo *li, char *src_dir, Slapi_Task *task)
             {
                 tmp_rval = PR_GetFileInfo64(filename1, &info);
                 if (tmp_rval == PR_SUCCESS && PR_FILE_DIRECTORY == info.type) {
-                    /* Is it CHANGELOG_BACKUPDIR? */
-                    if (0 == strcmp(CHANGELOG_BACKUPDIR, direntry->name)) {
-                        /* Yes, this is a changelog backup. */
-                        /* Get the changelog path */
-                        _dblayer_get_changelogdir(li, &changelogdir);
-                        continue;
-                    }
                     inst = ldbm_instance_find_by_name(li, (char *)direntry->name);
                     if (inst == NULL) {
                         slapi_log_err(SLAPI_LOG_ERR,
@@ -6019,6 +5935,14 @@ bdb_get_info(Slapi_Backend *be, int cmd, void **info)
         }
         break;
     }
+    case BACK_INFO_INSTANCE_DIR: {
+        if (li) {
+            ldbm_instance *inst = (ldbm_instance *)be->be_instance_info;
+            *(char **)info = dblayer_get_full_inst_dir(li, inst, NULL, 0);
+            rc = 0;
+        }
+        break;
+    }
     case BACK_INFO_LOG_DIRECTORY: {
         if (li) {
             *(char **)info = bdb_config_db_logdirectory_get_ext((void *)li);
@@ -6034,6 +5958,21 @@ bdb_get_info(Slapi_Backend *be, int cmd, void **info)
         rc = get_suffix_key(be, (struct _back_info_index_key *)info);
         break;
     }
+    case BACK_INFO_DBENV_CLDB: {
+        ldbm_instance *inst = (ldbm_instance *) be->be_instance_info;
+        if (inst->inst_changelog) {
+            rc = 0;
+        } else {
+            DB *db;
+            rc = dblayer_get_changelog(be, &db,DB_CREATE);
+        }
+        if (rc == 0) {
+           *(DB **)info = inst->inst_changelog;
+        } else {
+            *(DB **)info = NULL;
+        }
+        break;
+    }
     default:
         break;
     }
@@ -6069,7 +6008,13 @@ bdb_back_ctrl(Slapi_Backend *be, int cmd, void *info)
     switch (cmd) {
     case BACK_INFO_CRYPT_INIT: {
         back_info_crypt_init *crypt_init = (back_info_crypt_init *)info;
-        rc = back_crypt_init(crypt_init->be, crypt_init->dn,
+        Slapi_DN configdn;
+        slapi_sdn_init(&configdn);
+        be_getbasedn(be, &configdn);
+        char *crypt_dn = slapi_ch_smprintf("%s,%s",
+                        crypt_init->dn,
+                        slapi_sdn_get_dn(&configdn));
+        rc = back_crypt_init(crypt_init->be, crypt_dn,
                              crypt_init->encryptionAlgorithm,
                              &(crypt_init->state_priv));
         break;
@@ -6091,6 +6036,103 @@ bdb_back_ctrl(Slapi_Backend *be, int cmd, void *info)
                                       &(crypt_value->out));
         break;
     }
+    case BACK_INFO_DBENV_CLDB_REMOVE: {
+        DB *db = (DB *)info;
+        struct ldbminfo *li = (struct ldbminfo *)be->be_database->plg_private;
+        ldbm_instance *inst = (ldbm_instance *) be->be_instance_info;
+        if (li) {
+            dblayer_private *priv = (dblayer_private *)li->li_dblayer_private;
+            if (priv && priv->dblayer_env) {
+                char *instancedir;
+                slapi_back_get_info(be, BACK_INFO_INSTANCE_DIR, (void **)&instancedir);
+                char *path = slapi_ch_smprintf("%s/changelog.db", instancedir);
+                db->close(db, 0);
+                rc = bdb_db_remove_ex((bdb_db_env *)priv->dblayer_env, path, NULL, PR_TRUE);
+                inst->inst_changelog = NULL;
+                slapi_ch_free_string(&instancedir);
+            }
+        }
+        break;
+    }
+    case BACK_INFO_DBENV_CLDB_UPGRADE: {
+        struct ldbminfo *li = (struct ldbminfo *)be->be_database->plg_private;
+        char *oldFile = (char *)info;
+        if (li) {
+            dblayer_private *priv = (dblayer_private *)li->li_dblayer_private;
+            if (priv && priv->dblayer_env) {
+                DB_ENV *pEnv = ((bdb_db_env *)priv->dblayer_env)->bdb_DB_ENV;
+                if (pEnv) {
+                    char *instancedir;
+                    slapi_back_get_info(be, BACK_INFO_INSTANCE_DIR, (void **)&instancedir);
+                    char *newFile = slapi_ch_smprintf("%s/changelog.db", instancedir);
+                    rc = pEnv->dbrename(pEnv, 0, oldFile, 0, newFile, 0);
+                    slapi_ch_free_string(&instancedir);
+                }
+            }
+        }
+        break;
+    }
+    case BACK_INFO_CLDB_GET_CONFIG: {
+        /* get a config entry relative to the
+         * backend config entry
+         */
+        back_info_config_entry *config = (back_info_config_entry *)info;
+        struct ldbminfo *li = (struct ldbminfo *)be->be_database->plg_private;
+        Slapi_DN configdn;
+        slapi_sdn_init(&configdn);
+        be_getbasedn(be, &configdn);
+        char *config_dn = slapi_ch_smprintf("%s,%s",
+                        config->dn,
+                        slapi_sdn_get_dn(&configdn));
+        Slapi_PBlock *search_pb = slapi_pblock_new();
+        slapi_search_internal_set_pb(search_pb, config_dn, LDAP_SCOPE_BASE, "objectclass=*",
+                                     NULL, 0, NULL, NULL, li->li_identity, 0);
+        slapi_search_internal_pb(search_pb);
+        slapi_pblock_get(search_pb, SLAPI_PLUGIN_INTOP_RESULT, &rc);
+        if (LDAP_SUCCESS == rc ) {
+            Slapi_Entry **entries;
+            slapi_pblock_get(search_pb, SLAPI_PLUGIN_INTOP_SEARCH_ENTRIES, &entries);
+            if (entries && entries[0]) {
+                config->ce = slapi_entry_dup(entries[0]);
+            } else {
+                rc = -1;
+            }
+        }
+        slapi_free_search_results_internal(search_pb);
+        slapi_pblock_destroy(search_pb);
+        slapi_ch_free_string(&config_dn);
+        break;
+    }
+    case BACK_INFO_CLDB_SET_CONFIG: {
+        /* This control option allows a plugin to set a backend configuration
+         * entry without knowing the location of the backend config.
+         * It passes an entry with a relative dn and this dn is expanded by the
+         * backend config dn.
+         */
+        Slapi_DN fulldn;
+        Slapi_DN configdn;
+        struct ldbminfo *li = (struct ldbminfo *)be->be_database->plg_private;
+        Slapi_Entry *config_entry = (Slapi_Entry *)info;
+
+        slapi_sdn_init(&configdn);
+        be_getbasedn(be, &configdn);
+        char *newdn = slapi_ch_smprintf("%s,%s",
+                        slapi_entry_get_dn_const(config_entry),
+                        slapi_sdn_get_dn(&configdn));
+        slapi_sdn_init(&fulldn);
+        slapi_sdn_init_dn_byref(&fulldn, newdn);
+        slapi_entry_set_sdn(config_entry, &fulldn);
+        slapi_ch_free_string(&newdn);
+
+        Slapi_PBlock *pb = slapi_pblock_new();
+        slapi_pblock_init(pb);
+        slapi_add_entry_internal_set_pb(pb, config_entry, NULL,
+                                        li->li_identity, 0);
+        slapi_add_internal_pb(pb);
+        slapi_pblock_get(pb, SLAPI_PLUGIN_INTOP_RESULT, &rc);
+        slapi_pblock_destroy(pb);
+        break;
+    }
     default:
         break;
     }
diff --git a/ldap/servers/slapd/back-ldbm/db-bdb/bdb_ldif2db.c b/ldap/servers/slapd/back-ldbm/db-bdb/bdb_ldif2db.c
index 542147c..664c27f 100644
--- a/ldap/servers/slapd/back-ldbm/db-bdb/bdb_ldif2db.c
+++ b/ldap/servers/slapd/back-ldbm/db-bdb/bdb_ldif2db.c
@@ -706,6 +706,7 @@ bdb_db2ldif(Slapi_PBlock *pb)
     int decrypt = 0;
     int32_t dump_replica = 0;
     int dump_uniqueid = 1;
+    int dump_changelog = 0;
     int fd = STDOUT_FILENO;
     IDList *idl = NULL; /* optimization for -s include lists */
     int cnt = 0, lastcnt = 0;
@@ -816,6 +817,7 @@ bdb_db2ldif(Slapi_PBlock *pb)
     slapi_pblock_get(pb, SLAPI_DB2LDIF_FILE, &fname);
     slapi_pblock_get(pb, SLAPI_DB2LDIF_PRINTKEY, &printkey);
     slapi_pblock_get(pb, SLAPI_DB2LDIF_DUMP_UNIQUEID, &dump_uniqueid);
+    slapi_pblock_get(pb, SLAPI_LDIF_CHANGELOG, &dump_changelog);
 
     /* tsk, overloading printkey.  shame on me. */
     ok_index = !(printkey & EXPORT_ID2ENTRY_ONLY);
@@ -1285,6 +1287,12 @@ bdb_db2ldif(Slapi_PBlock *pb)
                       "export %s: Processed %d entries (100%%).\n",
                       inst->inst_name, cnt);
     }
+    if (run_from_cmdline && dump_changelog) {
+        return_value = plugin_call_plugins(pb, SLAPI_PLUGIN_BE_POST_EXPORT_FN);
+        slapi_log_err(SLAPI_LOG_INFO, "ldbm_back_ldbm2ldif",
+                      "export changelog for %s.\n", inst->inst_name);
+    }
+
 bye:
     if (idl) {
         idl_free(&idl);
diff --git a/ldap/servers/slapd/back-ldbm/dblayer.c b/ldap/servers/slapd/back-ldbm/dblayer.c
index c9f43c7..a8854b0 100644
--- a/ldap/servers/slapd/back-ldbm/dblayer.c
+++ b/ldap/servers/slapd/back-ldbm/dblayer.c
@@ -92,6 +92,7 @@
 
 #define NEWDIR_MODE 0755
 #define DB_REGION_PREFIX "__db."
+#define BE_CHANGELOG_FILE "changelog"
 
 
 static int dblayer_post_restore = 0;
@@ -397,6 +398,35 @@ dblayer_release_id2entry(backend *be __attribute__((unused)), DB *pDB __attribut
 }
 
 int
+dblayer_close_changelog(backend *be)
+{
+    ldbm_instance *inst;
+    DB *pDB = NULL;
+    int return_value = 0;
+
+    PR_ASSERT(NULL != be);
+    inst = (ldbm_instance *) be->be_instance_info;
+    PR_ASSERT(NULL != inst);
+
+    pDB = inst->inst_changelog;
+    if (pDB) {
+        return_value = pDB->close(pDB,0);
+        inst->inst_changelog = NULL;
+    }
+    return return_value;
+}
+
+int
+dblayer_erase_changelog_file(backend *be, struct attrinfo *a, PRBool use_lock, int no_force_chkpt)
+{
+    if ((NULL == be) || (NULL == be->be_database)) {
+        return 0;
+    }
+    /* TBD (LK) */
+    return 0;
+}
+
+int
 dblayer_close_indexes(backend *be)
 {
     ldbm_instance *inst;
@@ -465,6 +495,7 @@ dblayer_instance_close(backend *be)
     }
 
     return_value = dblayer_close_indexes(be);
+    return_value |= dblayer_close_changelog(be);
 
     /* Now close id2entry if it's open */
     pDB = inst->inst_id2entry;
@@ -605,6 +636,52 @@ dblayer_get_index_file(backend *be, struct attrinfo *a, DB **ppDB, int open_flag
     return return_value;
 }
 
+int dblayer_get_changelog(backend *be, DB** ppDB, int open_flags)
+{
+    ldbm_instance *inst = (ldbm_instance *) be->be_instance_info;
+    int return_value = -1;
+    DB *pDB = NULL;
+
+    *ppDB = NULL;
+
+    if (inst->inst_changelog) {
+        /* This means that the pointer is valid, so we should return it. */
+        *ppDB = inst->inst_changelog;
+        return 0;
+    }
+
+    /* only one thread should open the chgangelog, we can use the mutex
+     * for opening the index files.
+     */
+    PR_Lock(inst->inst_handle_list_mutex);
+    if (inst->inst_changelog) {
+        /* another thread set the handle while we were waiting on the lock */
+        *ppDB = inst->inst_changelog;
+        PR_Unlock(inst->inst_handle_list_mutex);
+        return 0;
+    }
+
+    /* attrinfo handle is still blank, and we have the mutex: open the
+     * index file and stuff it in the attrinfo.
+     */
+    return_value = dblayer_open_file(be, BE_CHANGELOG_FILE, open_flags,
+                                   NULL, &pDB);
+    if (0 == return_value) {
+        /* Opened it OK */
+        inst->inst_changelog = pDB;
+        /* And, most importantly, return something to the caller!*/
+        *ppDB = pDB;
+    } else {
+        /* Did not open it OK ! */
+        /* Do nothing, because return value and fact that we didn't
+         * store a DB* in the attrinfo is enough
+         */
+    }
+    PR_Unlock(inst->inst_handle_list_mutex);
+
+    return return_value;
+}
+
 /*
  * Unlock the db lib mutex here if we need to.
  */
diff --git a/ldap/servers/slapd/back-ldbm/proto-back-ldbm.h b/ldap/servers/slapd/back-ldbm/proto-back-ldbm.h
index 5b277b9..1187da2 100644
--- a/ldap/servers/slapd/back-ldbm/proto-back-ldbm.h
+++ b/ldap/servers/slapd/back-ldbm/proto-back-ldbm.h
@@ -81,6 +81,7 @@ int dblayer_get_index_file(backend *be, struct attrinfo *a, DB **ppDB, int creat
 int dblayer_release_index_file(backend *be, struct attrinfo *a, DB *pDB);
 int dblayer_erase_index_file(backend *be, struct attrinfo *a, PRBool use_lock, int no_force_chkpt);
 int dblayer_get_id2entry(backend *be, DB **ppDB);
+int dblayer_get_changelog(backend *be, DB** ppDB, int create);
 int dblayer_release_id2entry(backend *be, DB *pDB);
 int dblayer_txn_init(struct ldbminfo *li, back_txn *txn);
 int dblayer_txn_begin(backend *be, back_txnid parent_txn, back_txn *txn);
diff --git a/ldap/servers/slapd/backend.c b/ldap/servers/slapd/backend.c
index 78c00a5..c63fe23 100644
--- a/ldap/servers/slapd/backend.c
+++ b/ldap/servers/slapd/backend.c
@@ -271,6 +271,17 @@ slapi_be_gettype(Slapi_Backend *be)
 }
 
 Slapi_DN *
+be_getbasedn(Slapi_Backend *be, Slapi_DN *dn)
+{
+    if (be->be_state == BE_STATE_DELETED) {
+        slapi_sdn_set_ndn_byval(dn, NULL);
+    } else {
+        slapi_sdn_set_ndn_byref(dn, be->be_basedn);
+    }
+    return dn;
+}
+
+Slapi_DN *
 be_getconfigdn(Slapi_Backend *be, Slapi_DN *dn)
 {
     if (be->be_state == BE_STATE_DELETED) {
